from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String

Dropletutils_Read_10X_Counts_R_V0_1_0 = CommandToolBuilder(tool="dropletutils_read_10x_counts.R", base_command=["dropletutils-read-10x-counts.R"], inputs=[ToolInput(tag="in_samples", input_type=File(optional=True), prefix="--samples", doc=InputDocumentation(doc="A comma-separated list containing one or more directory names, each\ncorresponding to a 10X sample. Each directory should contain the 'matrix.mtx',\n'genes.tsv' and 'barcodes.tsv' files generated by CellRanger.\nAlternatively, strings may contain a path to a HDF5 file in the sparse\nmatrix format generated by 10X. These can be mixed with directory\nnames when type='auto'.")), ToolInput(tag="in_col_names", input_type=String(optional=True), prefix="--col-names", doc=InputDocumentation(doc="A logical scalar indicating whether the columns of the output object\nshould be named with the cell barcodes.")), ToolInput(tag="in_metadata_files", input_type=String(optional=True), prefix="--metadata-files", doc=InputDocumentation(doc="A comma-separated list containing one or more paths to\nmetadata files in .txt format, e.g. with cell type annotations.\nNote that gene ids must be consistent across the files\nand correspond to the matrix data.")), ToolInput(tag="in_metadata_columns", input_type=File(optional=True), prefix="--metadata-columns", doc=InputDocumentation(doc="A comma-separated list of metadata file field names that should be\nadded to the SCE object. By default, all columns are kept.")), ToolInput(tag="in_cell_id_column", input_type=File(optional=True), prefix="--cell-id-column", doc=InputDocumentation(doc="Name of the metadata file column that corresponds to the unique identifier\nof each cell in the dataset (e.g. barcode). Must correspond to column names in\nthe 10X directory.")), ToolInput(tag="in_output_object_file", input_type=File(optional=True), prefix="--output-object-file", doc=InputDocumentation(doc="File name in which to store serialized SingleCellExperiment object."))], outputs=[ToolOutput(tag="out_output_object_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_object_file", type_hint=File()), doc=OutputDocumentation(doc="File name in which to store serialized SingleCellExperiment object."))], container="quay.io/biocontainers/dropletutils-scripts:0.0.5--0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Dropletutils_Read_10X_Counts_R_V0_1_0().translate("wdl")

